//++
// Native.h
//--

//
// Misc Definitions
//
typedef long				NTSTATUS;
typedef unsigned int        UINT;
typedef void*				PVOID;
typedef PVOID				HANDLE;
typedef unsigned int*		PUINT;
typedef int                 BOOL;
typedef long*				LPLONG;

#define WINAPI				__stdcall
#define TRUE                1
#define FALSE               0


//
// Generic test for success on any status value (non-negative numbers
// indicate success).
//
#define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)

//
// semaphore object query structure
//
typedef struct _SEMAINFO {
	UINT		Count;		// current semaphore count
	UINT		Limit;		// max semaphore count
} SEMAINFO, *PSEMAINFO;


//
// only one query type for semaphores
//
#define SEMAQUERYINFOCLASS	0

//
// NT Function calls.
//
NTSTATUS 
WINAPI
NtQuerySemaphore(
	HANDLE Handle, 
	UINT InfoClass, 
	PSEMAINFO SemaInfo, 
	UINT InfoSize,
	PUINT RetLen 
);