//++
//  QuerySemaphore.c 
//
//  Non destructivley read semaphores
//  using native NT API
//
//  THIS SOFTWARE IS SUPPLIED "AS IS", AND EXPLICITLY
//  WITHOUT WARRANTY OF ANY KIND.
//
//	Thanks to OSR ( http://www.osr.com ) and sysinternals
//	( http://www.sysinternals.com ) for the information on 
//	how to use native NT functions.
//
//	Written by Hermann Schinagl, Febuary 1999
//             Hermann.Schinagl@gmx.net
//
//--

#include "Native.h"
#include "QuerySemaphore.h"

BOOL
WINAPI 
QuerySemaphore(
    HANDLE  hSemaphore,
    LPLONG  lpCount
)
{
	SEMAINFO			SemInfo;
	UINT				RetLen;
	NTSTATUS			Status;

	Status = NtQuerySemaphore( 
		hSemaphore, 
		SEMAQUERYINFOCLASS, 
		&SemInfo, 
		sizeof SemInfo,
		&RetLen
	);

    if( !NT_SUCCESS(Status) )
    {
		*lpCount = -1;
		return FALSE;
	}
	else
	{
		*lpCount = SemInfo.Count;
		return TRUE;
	}
}

